﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DevLeap.Linq.Syntax
{
    //
    // Listing 2-23
    // 

    public sealed class Developers : List<Developer>
    {
        public Developers(IEnumerable<Developer> items) : base(items) { }
    }

    public static class DevelopersEnumerable
    {
        public static IEnumerable<Developer> Where(
            this Developers source, Func<Developer, bool> predicate) {

                Console.WriteLine("Invoked Where extension method for Developers");

                return (source.AsEnumerable().Where(predicate));
        }

        public static IEnumerable<Developer> Where(
            this Developers source, Func<Developer, int, bool> predicate)
        {
            Console.WriteLine("Invoked Where extension method for Developers");

            return (source.AsEnumerable().Where(predicate));
        }
    }
}
