﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DevLeap.Linq.Entities
{
    public class Customer : Contact
    {
        public Customer()
        {
            this.Orders = new List<Order>();
        }

        public Decimal LastYearIncomes { get; set; }

        public ShippingAddressType ShippingAddress { get; set; }

        public virtual ICollection<Order> Orders { get; private set; }
    }

    public class ShippingAddressType
    {
        public String ShippingAddress { get; set; }

        public String ShippingCity { get; set; }

        public String ShippingPostalCode { get; set; }

        public String ShippingCountry { get; set; }
    }
}
