﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;
using DevLeap.Linq.Entities;

namespace DevLeap.Linq.LinqToEntitiesPOCO
{
    public class EF4SampleDBEntities: ObjectContext
    {
        public EF4SampleDBEntities(String connectionString)
            : base(connectionString, "EF4SampleDBEntities")
        {
            this.Contacts = base.CreateObjectSet<Contact>();
            
            this.ContextOptions.LazyLoadingEnabled = true;
        }

        public ObjectSet<Contact> Contacts { get; private set; }
    }
}
